<template>
  <div class="forscroll">
    <v-sheet height="64">
      <v-toolbar flat color="white">
        <v-btn :disabled="changes" outlined class="mr-4" color="grey darken-2" @click="setToday">Hoy</v-btn>
        <v-btn :disabled="changes" fab text small color="grey darken-2" @click="prev">
          <v-icon small>mdi-chevron-left</v-icon>
        </v-btn>
        <v-btn :disabled="changes" fab text small color="grey darken-2" @click="next">
          <v-icon small>mdi-chevron-right</v-icon>
        </v-btn>
        <v-toolbar-title v-if="$refs.calendar">{{ $refs.calendar.title }}</v-toolbar-title>

        <v-spacer></v-spacer>
      </v-toolbar>
    </v-sheet>
    <v-sheet :height="height">
      <v-calendar
        ref="calendar"
        v-model="value"
        color="primary"
        type="week"
        :events="events"
        :event-color="getEventColor"
        :event-ripple="false"
        @click:event="showEvent"
        @mousedown:event="startDrag"
        @mousedown:time="startTime"
        @mousemove:time="mouseMove"
        @mouseup:time="endDrag"
        @mouseleave.native="cancelDrag"
        locale="es"
        :first-interval="intervals.first"
        :interval-minutes="intervals.minutes"
        :interval-count="intervals.count"
        :interval-height="intervals.height"
        :short-intervals="shortIntervals"
        :interval-style="intervalStyle"
        :weekdays="weekdays"
      >
        <template #event="{ event, timed, eventSummary }">
          <div class="v-event-draggable" v-html="eventSummary()"></div>
          <div v-if="timed" class="v-event-drag-bottom" @mousedown.stop="extendBottom(event)"></div>
        </template>
      </v-calendar>
      <v-menu
        v-model="selectedOpen"
        :close-on-content-click="false"
        :activator="selectedElement"
        offset-x
      >
        <v-card color="grey lighten-4">
          <v-card-actions>
            <v-btn text color="secondary" @click="eliminar">Eliminar</v-btn>
          </v-card-actions>
        </v-card>
      </v-menu>
    </v-sheet>
  </div>
</template>

<script>
const intervalsDefault = {
  first: 13,
  minutes: 30,
  count: 32,
  height: 40
};

export default {
  props: {
    styleInterval: String,
    idTutor: String,
    units: Array,
    currUnit : String,
    height: {default: 700,
    type: Number}
  },
  data: () => ({
    stylings: {
      default(interval) {
        return undefined;
      },
      workday(interval) {
        const inactive = true;
        const startOfHour = interval.minute === 0;
        const dark = this.dark;
        const mid = dark ? "rgba(255,255,255,0.1)" : "rgba(0,0,0,0.1)";

        return {
          backgroundColor: inactive
            ? dark
              ? "rgba(0,0,0,0.4)"
              : "rgba(0,0,0,0.2)"
            : undefined,
          borderTop: startOfHour ? undefined : "1px dashed " + mid
        };
      },
      past(interval) {
        return {
          backgroundColor: interval.past
            ? this.dark
              ? "rgba(0,0,0,0.4)"
              : "rgba(0,0,0,0.2)"
            : undefined
        };
      }
    },
    units2:[],
    unit : 0,
    changes: false,
    isExtended: false,
    selectedEvent: {},
    selectedElement: null,
    selectedOpen: false,
    //styleInterval: "",
    shortIntervals: false,
    intervals: intervalsDefault,
    value: "",
    events: [],
    orig: [],
    colors: ["#1DE9B1"],
    names: [
      "Meeting",
      "Holiday",
      "PTO",
      "Travel",
      "Event",
      "Birthday",
      "Conference",
      "Party"
    ],
    dragEvent: null,
    dragStart: null,
    createEvent: null,
    createStart: null,
    extendOriginal: null,
    limite: 13,
    available: [],
    available2: [],
    unavailable:[],
    needAvailabity: false,
    weekdays: [1, 2, 3, 4, 5, 6, 0],
    eventosOrig:[],
    ini11 : "",
    fin11: ""
  }),
  methods: {
    setToday() {
      this.value = "";
    },
    prev() {
      this.$refs.calendar.prev();
      this.ini();
    },
    next() {
      this.$refs.calendar.next();
      this.ini();
    },
    startDrag({ event, timed }) {
      if (event && timed) {
        this.dragEvent = event;
        this.dragTime = null;
        this.extendOriginal = null;
      }
    },
    startTime(tms) {
      const mouse = this.toTime(tms);
      if (this.dragEvent && this.dragTime === null) {
        const start = this.dragEvent.start;
        this.dragTime = mouse - start;
      } else {
        this.createStart = this.roundTime(mouse);
        this.createEvent = {
          id: '1',
          name: "",
          color: "#01579B",
          start: this.createStart,
          end: this.createStart + 30 * 60 * 1000,
          timed: true
        };
        if (this.valid(this.createEvent.start, this.createEvent.end, -1)) {
          this.events.push(this.createEvent);
        }
      }
    },
    extendBottom(event) {
      this.createEvent = event;
      this.createStart = event.start;
      this.extendOriginal = event.end;
      this.isExtended = true;
    },
    mouseMove(tms) {
      const mouse = this.toTime(tms);
      if (this.dragEvent && this.dragTime !== null) {
        const index = this.events.findIndex(event => event === this.dragEvent);
        const start = this.dragEvent.start;
        const end = this.dragEvent.end;
        const duration = end - start;
        const newStartTime = mouse - this.dragTime;
        const newStart = this.roundTime(newStartTime);
        const newEnd = newStart + duration;

        if (this.valid(newStartTime, newEnd, index)) {
          this.dragEvent.start = newStart;
          this.dragEvent.end = newEnd;
        }
      } else if (this.createEvent && this.createStart !== null) {
        const index = this.events.findIndex(
          event => event === this.createEvent
        );
        const mouseRounded = this.roundTime(mouse, false);
        const min = Math.min(mouseRounded, this.createStart);
        const max = Math.max(mouseRounded, this.createStart);
        if (this.valid(min, max, index)) {
          this.createEvent.start = min;
          this.createEvent.end = max;
        }
      }
    },
    endDrag() {
      this.dragTime = null;
      this.dragEvent = null;
      this.createEvent = null;
      this.createStart = null;
      this.extendOriginal = null;
      this.normalize();// = true;
    },
    cancelDrag() {
      if (this.createEvent) {
        if (this.extendOriginal) {
          this.createEvent.end = this.extendOriginal;
        } else {
          const i = this.events.indexOf(this.createEvent);
          if (i !== -1) {
            this.events.splice(i, 1);
          }
        }
      }

      this.createEvent = null;
      this.createStart = null;
      this.dragTime = null;
      this.dragEvent = null;
    },
    roundTime(time, down = true) {
      const roundTo = 30; // minutes
      const roundDownTime = roundTo * 60 * 1000;

      return down
        ? time - (time % roundDownTime)
        : time + (roundDownTime - (time % roundDownTime));
    },
    toTime(tms) {
      return new Date(
        tms.year,
        tms.month - 1,
        tms.day,
        tms.hour,
        tms.minute
      ).getTime();
    },
    getEventColor(event) {
      const rgb = parseInt(event.color.substring(1), 16);
      const r = (rgb >> 16) & 0xff;
      const g = (rgb >> 8) & 0xff;
      const b = (rgb >> 0) & 0xff;

      return event === this.dragEvent
        ? `rgba(${r}, ${g}, ${b}, 0.7)`
        : event === this.createEvent
        ? `rgba(${r}, ${g}, ${b}, 0.7)`
        : event.color;
    },
    rnd(a, b) {
      return Math.floor((b - a + 1) * Math.random()) + a;
    },
    rndElement(arr) {
      return arr[this.rnd(0, arr.length - 1)];
    },
    valid(start, end, index) {
      let valid = true;
      for (let it in this.events) {
        if (
          it != index &&
          end > this.events[it].start &&
          start < this.events[it].end
        ) {
          valid = valid && false;
        }
      }
      let aux = new Date().getTime();
        aux = this.roundTime(aux, false);
        if (start >= aux) {
          valid = valid && true;       
        }else{     
          valid = valid && false;
        }
      for (let it in this.unavailable) {
          if (
            end > this.unavailable[it].start &&
            start < this.unavailable[it].end
          ) {
            valid = false;
            return valid;
          }
        }
      if (this.needAvailabity) {
        for (let it in this.available) {
          if (
            start >= this.available[it].start &&
            end <= this.available[it].end
          ) {
            valid = valid && true;
            return valid;
          }
        }
        valid = valid && false;
      } 
      return valid;
    },
    format(time) {
      let d = new Date(time).toISOString();
      return d;
    },
    normalize() {
      this.events.sort((a, b) => (a.start > b.start ? 1 : -1));
      let events = [];
      try {
        let aux = null;
        for (let it in this.events) {
          if (aux === null) {
            aux = new Object();
            Object.assign(aux, this.events[it]);
          }
          if (
            it == this.events.length - 1 ||
            (it < this.events.length - 1 &&
              (aux.end != this.events[parseInt(it) + 1].start ||
                aux.id != this.events[parseInt(it) + 1].id ||
                aux.color != this.events[parseInt(it) + 1].color))
          ) {
            let aux2 = {};
            Object.assign(aux2, aux);
            let indName = 0
            if(this.styleInterval != "workday") indName = this.units.findIndex(unit => unit.idUnidad === aux2.id)
           if(this.styleInterval != "workday") aux2.name = "Nuevo Horario"
           if(this.styleInterval != "workday")  if(indName != -1) aux2.name = this.units[indName].codigo
            events.push(aux2);
            aux = null;
          } else if (
            it < this.events.length - 1 &&
            aux.end == this.events[parseInt(it) + 1].start &&
            aux.id == this.events[parseInt(it) + 1].id &&
            aux.color == this.events[parseInt(it) + 1].color
          ) {
            aux.end = this.events[parseInt(it) + 1].end;
          }
        }
        this.events = events;
        this.hasChanges()
      } catch (error) {
         this.$store.commit("setError", error);
      }
    },
    showEvent({ nativeEvent, event }) {
      let aux = new Date().getTime();
        aux = this.roundTime(aux, false);
        if(event.start < aux) return
        if(event.color == "#F36E23") return
      try {
        if (this.isExtended) {
          this.isExtended = false;
          this.selectedOpen = false;
        } else if (this.selectedOpen) {
          this.selectedOpen = false;
        } else {
          this.selectedOpen = false;
          const open = () => {
            this.selectedEvent = new Object();
            this.selectedEvent = event;
            this.selectedElement = nativeEvent.target;
            setTimeout(() => (this.selectedOpen = true), 10);
          };

          if (this.selectedOpen) {
            this.selectedOpen = false;
            setTimeout(open, 10);
          } else {
            open();
          }
        }

        nativeEvent.stopPropagation();
      } catch (error) {
        this.$store.commit("setError", error);
      }
    },
    eliminar() {
      this.selectedOpen = false;
      const index = this.events.findIndex(
        event => event === this.selectedEvent
      );
      const i = this.events.indexOf(this.selectedEvent);
      if (index != -1) {
        this.events.splice(i, 1);
      }
      this.hasChanges()
    },
    hasChanges(){
      let a = JSON.stringify(this.orig)
      let b = JSON.stringify(this.events)
      
      this.changes = !(a == b)
    },
    async ini() {
      //let value = ""
      this.events = [];
      let ini2 = "";
      let fin2 = 0;
      let curr = this.value;
      let tiempo = 0;
      let difdia = ""
      if (this.value == "") {
        let dia = new Date().getDay()
        tiempo = new Date().getTime()
        tiempo = tiempo - (dia - 1) * 24 * 60 * 60 * 1000 - 5 * 60 * 60 * 1000
        curr = new Date(tiempo).toISOString().substr(0, 10)
      }
      else{
        let date_str2 = this.value + "T00:00:00Z"
        difdia = new Date(date_str2).getDay()
        let agfd = new Date(date_str2).getTime() - (difdia-1) * 24 * 60 * 60 *1000 - 5 * 60 * 60 * 1000
        curr = new Date(agfd).toISOString().substr(0, 10)
      }
      ini2 = curr + "T05:00:00.000Z";
      tiempo = new Date(ini2).getTime();
      fin2 = tiempo + 7 * 24 * 60 * 60 * 1000 - 1;
      let fin = new Date(fin2).toISOString();
      let ini = new Date(ini2).toISOString();
      this.ini11= ini
      this.fin11 = fin
      let listarNoAprobados = true;
      try {
        if (this.idTutor !== null && this.idTutor !== "") {
          let {
            data: { data: eventos }
          } = await this.$api.getTutorAvailability(
            this.idTutor,
            listarNoAprobados,
            ini,
            fin
          );
          this.eventosOrig = eventos
          this.updateUnit(this.currUnit, eventos)
          
        }
        this.updateUnit2()
        //  this.styleInterval = "workday"
      } catch (error) {
        this.$store.commit("setError", error);
      }
    },
    getEvents(unidad = null) {
      this.changes = false;
      if(unidad === null )return this.events;
      let newEvents = []
      for(let it in this.events){
        if(this.events[it].id == '1' || this.events[it].id == unidad){
          let aux = {}
          Object.assign(aux,this.events[it])
          newEvents.push(aux)
        }
      }
      return newEvents
    },
    updateUnit(value=this.currUnit,eventos=this.eventosOrig){
      this.events = [];
      this.available =[]
      this.unavailable =[]
      this.available2 = []
          for (let it in eventos) {
            let date_str = eventos[it].fecha
            date_str = date_str.includes('+') ? date_str : date_str + "Z"
            let dia = new Date(date_str).getTime();
            let id = eventos[it].unidad.idUnidad// === null ? '1' : '0'
            let color = eventos[it].sesion===null ? "#4DB6AC" : "#F36E23"
            let aux = {
              id: id,
              name: "",
              color: color,//this.rndElement(this.colors),
              start: dia,
              end: dia + 30 * 60 * 1000,
              timed: true
            };
           if(aux.id == value && eventos[it].sesion===null ) this.available.push(aux)
           if(aux.id == value) this.available2.push(aux)
           if(aux.id != value ) this.unavailable.push(aux)
            this.events.push(aux);
          }
    },
    updateUnit2(){
      this.normalize();
      //  this.available = [...this.events];
        this.stylings["workday"] = function(interval) {
          // this.needAvailabity = true;
          let inactive = true;
          let iso = interval.date + "T" + interval.time + ":00.000Z";
          let start = new Date(iso).getTime() + 5 * 60 * 60 * 1000;
          let end = start + 30 * 60 * 1000;
          for (let it in this.available) {
            if (
              start >= this.available[it].start &&
              end <= this.available[it].end
            ) {
              inactive = interval.past || false;
              break;
            }
          }
          let startOfHour = interval.minute === 0;
          let dark = this.dark;
          let mid = dark ? "rgba(255,255,255,0.1)" : "rgba(0,0,0,0.1)";
          return {
            backgroundColor: inactive
              ? dark
                ? "rgba(0,0,0,0.4)"
                : "rgba(0,0,0,0.2)"
              : undefined,
            borderTop: startOfHour ? undefined : "1px dashed " + mid
          };
        };
        this.stylings["past"] = function(interval) {
          // this.needAvailabity = true;
          let inactive = interval.past;
          let iso = interval.date + "T" + interval.time + ":00.000Z";
          let start = new Date(iso).getTime() + 5 * 60 * 60 * 1000;
          let end = start + 30 * 60 * 1000;
          for (let it in this.unavailable) {
            if (
              start >= this.unavailable[it].start &&
              end <= this.unavailable[it].end
            ) {
              inactive = inactive || true;
              break;
            }
            else inactive = inactive || false
          }
          let startOfHour = interval.minute === 0;
          let dark = this.dark;
          let mid = dark ? "rgba(255,255,255,0.1)" : "rgba(0,0,0,0.1)";
          return {
            backgroundColor: inactive
              ? dark
                ? "rgba(0,0,0,0.4)"
                : "rgba(0,0,0,0.2)"
              : undefined,
            borderTop: startOfHour ? undefined : "1px dashed " + mid
          };
        };
        if (this.styleInterval == "workday") {
          this.needAvailabity = true;
          this.events = [];
          // this.styleInterval = "workday"
        } else {
          this.needAvailabity = false;
          //this.events = []
          this.events = [...this.available2]
          this.normalize()
          this.available2 =[]
          

        }
        
        this.orig = [...this.events]
        this.hasChanges()
    },
    getIni(){
      return this.ini11
    },
    getFin(){
      return this.fin11
    }
  },
  mounted() {
    this.ini();
    this.$refs.calendar.scrollToTime("07:30");
  },
  watch: {
    idTutor: {
      immediate: true,
      deep: true,
      handler(old, now) {
        this.ini();
      },
    },
  },
  computed: {
    intervalStyle() {
      return this.stylings[this.styleInterval].bind(this);
    }
  },
};
</script>

<style scoped lang="scss">
.controls {
  position: relative;
}
.v-event-draggable {
  padding-left: 6px;
}

.v-event-timed {
  user-select: none;
  -webkit-user-select: none;
}

.v-event-drag-bottom {
  position: absolute;
  left: 0;
  right: 0;
  bottom: 4px;
  height: 4px;
  cursor: ns-resize;

  &::after {
    display: none;
    position: absolute;
    left: 50%;
    height: 4px;
    border-top: 1px solid white;
    border-bottom: 1px solid white;
    width: 16px;
    margin-left: -8px;
    opacity: 0.8;
    content: "";
  }

  &:hover::after {
    display: block;
  }
}
.forscroll{
  margin-left: 50px;
  margin-right: 50px; 
}
</style>
